extends Node
class_name ReservationService

@onready var _main: Main = get_tree().get_current_scene()

func is_time_busy(new_start_time_minutes, new_finish_time_minutes):
	var repo = _main.get_reservation_repo()
	var reservations = repo.list_reservations()
	var current_reservation_id = repo.get_current_reservation_id()

	for reservation in reservations:
		if reservation.id == current_reservation_id:
			continue

		var other_start_time = reservation.start_time
		var other_finish_time = reservation.finish_time
		var other_start_time_minutes = other_start_time.hours*60 + other_start_time.minutes
		var other_finish_time_minutes = other_finish_time.hours*60 + other_finish_time.minutes

		var is_busy = (
			(
				new_start_time_minutes >= other_start_time_minutes and
				new_start_time_minutes < other_finish_time_minutes
			) or (
				new_finish_time_minutes > other_start_time_minutes and 
				new_finish_time_minutes <= other_finish_time_minutes
			) or (
				new_start_time_minutes >= other_start_time_minutes and 
				new_finish_time_minutes <= other_finish_time_minutes
			) or (
				new_start_time_minutes <= other_start_time_minutes and 
				new_finish_time_minutes >= other_finish_time_minutes
			)
 		)

		if is_busy:
			return true

	return false
